/* BrainFsck Print-Code Generator
 *
 * Copyright (c) 2000, Brian Luft.  
 */

#include <string.h>
#include <math.h>
#include <SupportDefs.h>
#include <stdio.h>

int main(void)
{
	printf("Text to print to screen: ");
	fflush(stdout);
	char buf[1024];
	fgets(buf, 1024, stdin);
	fflush(stdin);
	printf("++++++++[>++++++++<-]>");
	char last_letter = 64;
	int i;
	int NumtoAdd = 0;
	for(i = 0; i <= strlen(buf) - 1; i++)
	{
		NumtoAdd = 0;
		int NumIncDecs = 0;
		if(buf[i] > last_letter)
		{
			// We're gonna have to + to get to this letter
			for(int a = 1; a <= buf[i] - last_letter; a++)
				NumIncDecs++;
			// Optimization!
			if(NumIncDecs <= 4)
			{
				for(int counter = 1; counter <= NumIncDecs; counter++)
					printf("+");
			}
			else
			{
//loopStartAdd:
				bool printed = false;
				// Optimize! First, find the middle-most pair of factors
				for(int counter = sqrt(NumIncDecs)+1; counter--; counter > 1)
				{
					if(NumIncDecs % counter == 0)
					{
						// Divisible!  Make sure it isn't the same number :P
						if(counter != 1)
						{
							// OK, print that baby out
							printf("<");
							for(int h = 1; h <= counter; h++)
								printf("+");
							printf("[>");
							for(int h = 1; h <= NumIncDecs/counter; h++)
								printf("+");
							printf("<-]>");
							printed = true;
						}
						break;
					}
				}
				if(!printed)
				{
					for(int counter = 1; counter <= NumIncDecs; counter++)
						printf("+");

#if 0
					// Hrm... maybe try it with one left over?
					NumtoAdd++;
					if(NumtoAdd > 15)
					{
						for(int counter = 1; counter <= NumIncDecs; counter++)
							printf("+");
					}
					else
					{
						goto loopStartAdd;
						// ^-- Forgive me for using goto... it is very convenient here
						// I swear... I'll never do it again, except for the subtraction below
					}
#endif
				}

//				for(int counter = 1; counter <= NumtoAdd; counter++)
//					printf("+");
			}
		}
		else
		{
			// We're gonna have to - to get to this letter
			for(int a = 1; a <= last_letter - buf[i]; a++)
				NumIncDecs++;
			// Optimization!
			if(NumIncDecs <= 4)
			{
				for(int counter = 1; counter <= NumIncDecs; counter++)
					printf("-");
			}
			else
			{
//loopStartSub:
				bool printed = false;
				// Optimize! First, find the middle-most pair of factors
				for(int counter = sqrt(NumIncDecs)+1; counter--; counter > 1)
				{
					if(NumIncDecs % counter == 0)
					{
						// Divisible!  Make sure it isn't the same number :P
						if(counter != 1)
						{
							// OK, print that baby out
							printf("<");
							for(int h = 1; h <= counter; h++)
								printf("+");
							printf("[>");
							for(int h = 1; h <= NumIncDecs/counter; h++)
								printf("-");
							printf("<-]>");
							printed = true;
						}
						break;
					}
				}
				if(!printed)
				{
					for(int counter = 1; counter <= NumIncDecs; counter++)
						printf("-");

#if 0
					// Hrm... maybe try it with one left over?
					NumtoAdd++;
					if(NumtoAdd > 15)
					{
						for(int counter = 1; counter <= NumIncDecs; counter++)
							printf("-");
					}
					else
					{
						goto loopStartSub;
						// ^-- Forgive me for using goto... it is very convenient here
						// I swear... I'll never do it again
					}
#endif
				}
//				for(int counter = 1; counter <= NumtoAdd; counter++)
//					printf("-");
			}
		}	
		last_letter = buf[i];
		printf(".");
	}
	printf("\n");
	fflush(stdout);
	return(0);
}